Index: trunk/src/VBox/Additions/3D/mesa/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/3D/mesa/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Additions/3D/mesa/Makefile.kmk	(revision 84540)
@@ -123,5 +123,5 @@
 	$(VBOX_MESA)/src/gallium/state_trackers/wgl \
 	$(TEMPLATE_VBoxMesa3DGuestR3Dll_INCS)
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 TEMPLATE_VBoxMesa3DGuestR3Lib_DEFS          = \
 	$(TEMPLATE_VBoxMesa3DGuestR3Dll_DEFS) \
Index: trunk/src/VBox/Additions/WINNT/VBoxTray/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxTray/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Additions/WINNT/VBoxTray/Makefile.kmk	(revision 84540)
@@ -26,5 +26,5 @@
 endif
 VBoxTray_SDKS     = ReorderCompilerIncs $(VBOX_WINDDK_GST)
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
  VBoxTray_DEFS   := VBOX_WITH_HGCM VBOX_BUILD_TARGET="$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)"
 else
Index: trunk/src/VBox/Additions/common/VBoxService/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/common/VBoxService/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Additions/common/VBoxService/Makefile.kmk	(revision 84540)
@@ -88,5 +88,5 @@
 	$(if $(VBOX_WITH_HGCM),VBOX_WITH_HGCM,)
 
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 VBoxService_DEFS         += VBOX_BUILD_TARGET="$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)"
 else
Index: trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Devices/Makefile.kmk	(revision 84540)
@@ -1305,5 +1305,5 @@
    tstIntNetHardened-1_TEMPLATE = VBoxR3HardenedTstExe
    tstIntNetHardened-1_NAME     = tstIntNet-1
-   ifdef KMK_WITH_QUOTING
+   ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
     tstIntNetHardened-1_DEFS    = PROGRAM_NAME_STR="tstIntNet-1"
    else
@@ -1511,5 +1511,5 @@
  	IN_VMSVGA3D \
  	VBOX_WINE_WITH_IPRT
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
  VBoxSVGA3D_DEFS        += \
  	WINE_UNICODE_API= \
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/Makefile.kmk
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/Makefile.kmk	(revision 84540)
@@ -108,5 +108,5 @@
  DLLS += VBoxDTraceCmd
  VBoxDTraceCmd_TEMPLATE = VBoxR3ExtPackDTrace
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
  VBoxDTraceCmd_DEFS = RTMEM_WRAP_TO_EF_APIS VBOX_EXTPACK_VBOXDTRACE_MANGLED_NAME="$(VBOX_EXTPACK_VBOXDTRACE_MANGLED_NAME)"
  else
Index: trunk/src/VBox/HostDrivers/Support/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/Support/testcase/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/HostDrivers/Support/testcase/Makefile.kmk	(revision 84540)
@@ -109,5 +109,5 @@
 
 tstGIP-2Hardened_TEMPLATE = VBoxR3HardenedTstExe
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
  tstGIP-2Hardened_DEFS = PROGRAM_NAME_STR="tstGIP-2"
 else
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/Makefile.kmk	(revision 84540)
@@ -401,5 +401,5 @@
 		$(PATH_SUB_CURRENT)/win/nobj/VBoxNetFltNobjT.idl \
 		| $$(dir $$@)
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 	$(VBOX_MIDL_REDIRECT) $(VBOX_WIN_MIDL) /nologo \
 		/out $(call VBOX_FN_MAKE_WIN_PATH,$(VBoxNetFltNobj_0_OUTDIR)) \
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Makefile.kmk
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Makefile.kmk	(revision 84540)
@@ -48,5 +48,5 @@
 endif
 VBoxUSB_SDKS        = ReorderCompilerIncs $(VBOX_WINDDK) $(VBOX_WINPSDK)INCS
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
  VBoxUSB_DEFS      := IN_RT_R0 IN_SUP_R0 VBOX_DBG_LOG_NAME="USBDev"
 else
@@ -80,5 +80,5 @@
 VBoxUSBMon_SDKS        = ReorderCompilerIncs $(VBOX_WINDDK) $(VBOX_WINPSDK)INCS
 VBoxUSBMon_DEFS        = IN_RT_R0 IN_SUP_R0 NTDDI_WINNT=_NTDDI_VISTA VBOXUSBFILTERMGR_USB_SPINLOCK
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
  VBoxUSBMon_DEFS      += VBOX_DBG_LOG_NAME="USBMon"
 else
Index: trunk/src/VBox/Main/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Main/Makefile.kmk	(revision 84540)
@@ -1245,5 +1245,5 @@
 endif # !win
 
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 glue/VBoxLogRelCreate.cpp_DEFS = KBUILD_TYPE="$(KBUILD_TYPE)"
 else
@@ -1313,5 +1313,5 @@
  DLLS += VBoxProxyStub
  VBoxProxyStub_TEMPLATE = VBOXMAINCOMP
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   VBoxProxyStub_DEFS   := REGISTER_PROXY_DLL PROXY_CLSID_IS=$(quote $(VBOX_MIDL_PROXY_CLSID_IS))
  else
Index: trunk/src/VBox/Main/src-helper-apps/OpenGLTest/Makefile.kmk
===================================================================
--- trunk/src/VBox/Main/src-helper-apps/OpenGLTest/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Main/src-helper-apps/OpenGLTest/Makefile.kmk	(revision 84540)
@@ -48,5 +48,5 @@
   VBoxTestOGL_DEFS.darwin      = DARWIN=1 GL_GLEXT_LEGACY _GNU_SOURCE
   VBoxTestOGL_DEFS.freebsd     = FreeBSD=1 _GNU_SOURCE
-  ifdef KMK_WITH_QUOTING
+  ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
    VBoxTestOGL_DEFS = VBOX_BUILD_TARGET="$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)"
   else
Index: trunk/src/VBox/NetworkServices/Dhcpd/Makefile.kmk
===================================================================
--- trunk/src/VBox/NetworkServices/Dhcpd/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/NetworkServices/Dhcpd/Makefile.kmk	(revision 84540)
@@ -50,5 +50,5 @@
 VBoxNetDHCP_INCS += . $(addprefix ../../Devices/Network/lwip-new/,$(LWIP_INCS))
 
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 VBoxNetDHCP_DEFS      = KBUILD_TYPE="$(KBUILD_TYPE)"
 else
Index: trunk/src/VBox/NetworkServices/NAT/Makefile.kmk
===================================================================
--- trunk/src/VBox/NetworkServices/NAT/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/NetworkServices/NAT/Makefile.kmk	(revision 84540)
@@ -37,5 +37,5 @@
 VBoxNetNATHardened_TEMPLATE = VBOXR3HARDENEDEXE
 VBoxNetNATHardened_NAME     = VBoxNetNAT
-  ifdef KMK_WITH_QUOTING
+  ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 VBoxNetNATHardened_DEFS     = SERVICE_NAME="VBoxNetNAT"
   else
Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 84540)
@@ -154,5 +154,5 @@
 	IPRT_BLDCFG_VERSION_MINOR=$(VBOX_VERSION_MINOR) \
 	IPRT_BLDCFG_VERSION_BUILD=$(VBOX_VERSION_BUILD)
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 common/misc/buildconfig.cpp_DEFS += \
 	IPRT_BLDCFG_VERSION_STRING="$(VBOX_VERSION_STRING)" \
@@ -2183,5 +2183,5 @@
 endif
 ifdef VBOX_WITH_DTRACE_R3
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   VBoxRT_DEFS                 += IPRT_WITH_DTRACE IPRT_DTRACE_INCLUDE="dtrace/iprt.h"
  else
@@ -2652,5 +2652,5 @@
 endif
 if defined(VBOX_WITH_DTRACE_R0) && !defined(VBOX_ONLY_VALIDATIONKIT)
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   RuntimeR0_DEFS        += IPRT_WITH_DTRACE IPRT_DTRACE_PREFIX=VBOXVMM_ IPRT_DTRACE_INCLUDE="dtrace/VBoxVMM.h"
  else
Index: trunk/src/VBox/Runtime/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/testcase/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Runtime/testcase/Makefile.kmk	(revision 84540)
@@ -773,5 +773,5 @@
  tstRTR0DbgKrnlInfoDriverHardened_TEMPLATE = VBoxR3HardenedTstExe
  tstRTR0DbgKrnlInfoDriverHardened_NAME = tstRTR0DbgKrnlInfoDriver
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   tstRTR0DbgKrnlInfoDriverHardened_DEFS = PROGRAM_NAME_STR="tstRTR0DbgKrnlInfoDriver"
  else
@@ -799,5 +799,5 @@
  tstRTR0MemUserKernelDriverHardened_TEMPLATE = VBoxR3HardenedTstExe
  tstRTR0MemUserKernelDriverHardened_NAME = tstRTR0MemUserKernelDriver
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   tstRTR0MemUserKernelDriverHardened_DEFS = PROGRAM_NAME_STR="tstRTR0MemUserKernelDriver"
  else
@@ -824,5 +824,5 @@
  tstRTR0SemMutexDriverHardened_TEMPLATE = VBoxR3HardenedTstExe
  tstRTR0SemMutexDriverHardened_NAME = tstRTR0SemMutexDriver
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   tstRTR0SemMutexDriverHardened_DEFS = PROGRAM_NAME_STR="tstRTR0SemMutexDriver"
  else
@@ -849,5 +849,5 @@
  tstRTR0ThreadDriverHardened_TEMPLATE = VBoxR3HardenedTstExe
  tstRTR0ThreadDriverHardened_NAME = tstRTR0ThreadDriver
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   tstRTR0ThreadDriverHardened_DEFS = PROGRAM_NAME_STR="tstRTR0ThreadDriver"
  else
@@ -874,5 +874,5 @@
  tstRTR0TimerDriverHardened_TEMPLATE = VBoxR3HardenedTstExe
  tstRTR0TimerDriverHardened_NAME = tstRTR0TimerDriver
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   tstRTR0TimerDriverHardened_DEFS = PROGRAM_NAME_STR="tstRTR0TimerDriver"
  else
@@ -899,5 +899,5 @@
  tstRTR0ThreadPreemptionDriverHardened_TEMPLATE = VBoxR3HardenedTstExe
  tstRTR0ThreadPreemptionDriverHardened_NAME = tstRTR0ThreadPreemptionDriver
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   tstRTR0ThreadPreemptionDriverHardened_DEFS = PROGRAM_NAME_STR="tstRTR0ThreadPreemptionDriver"
  else
Index: trunk/src/VBox/Runtime/tools/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/tools/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/Runtime/tools/Makefile.kmk	(revision 84540)
@@ -46,5 +46,5 @@
  	IPRT_BLDCFG_VERSION_MINOR=$(VBOX_VERSION_MINOR) \
  	IPRT_BLDCFG_VERSION_BUILD=$(VBOX_VERSION_BUILD)
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
   bldRTIsoMaker_DEFS += \
  	IPRT_BLDCFG_VERSION_STRING="$(VBOX_VERSION_STRING)" \
Index: trunk/src/VBox/VMM/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/VMM/Makefile.kmk	(revision 84540)
@@ -247,5 +247,5 @@
 
 # SSM wish to know the build type, host os and arch.
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 VMMR3/SSM.cpp_DEFS +=\
 	KBUILD_TYPE="$(KBUILD_TYPE)" \
Index: trunk/src/VBox/VMM/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/VMM/testcase/Makefile.kmk	(revision 84540)
@@ -218,5 +218,5 @@
 tstGlobalConfigHardened_TEMPLATE = VBoxR3HardenedTstExe
 tstGlobalConfigHardened_NAME     = tstGlobalConfig
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstGlobalConfigHardened_DEFS     = PROGRAM_NAME_STR="tstGlobalConfig"
  else
@@ -250,5 +250,5 @@
 tstMMHyperHeapHardened_TEMPLATE = VBoxR3HardenedTstExe
 tstMMHyperHeapHardened_NAME     = tstMMHyperHeap
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstMMHyperHeapHardened_DEFS     = PROGRAM_NAME_STR="tstMMHyperHeap"
  else
@@ -279,5 +279,5 @@
 tstCFGMHardened_TEMPLATE = VBoxR3HardenedTstExe
 tstCFGMHardened_NAME     = tstCFGM
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstCFGMHardened_DEFS     = PROGRAM_NAME_STR="tstCFGM"
  else
@@ -321,5 +321,5 @@
 tstVMREQHardened_TEMPLATE = VBOXR3HARDENEDEXE
 tstVMREQHardened_NAME     = tstVMREQ
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstVMREQHardened_DEFS     = PROGRAM_NAME_STR="tstVMREQ"
  else
@@ -341,5 +341,5 @@
 tstAnimateHardened_TEMPLATE = VBOXR3HARDENEDEXE
 tstAnimateHardened_NAME     = tstAnimate
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstAnimateHardened_DEFS     = PROGRAM_NAME_STR="tstAnimate"
  else
@@ -372,5 +372,5 @@
 tstVMMHardened_TEMPLATE = VBOXR3HARDENEDEXE
 tstVMMHardened_NAME     = tstVMM
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstVMMHardened_DEFS     = PROGRAM_NAME_STR="tstVMM"
  else
@@ -405,5 +405,5 @@
 tstMicroHardened_TEMPLATE = VBOXR3HARDENEDEXE
 tstMicroHardened_NAME     = tstMicro
- ifdef KMK_WITH_QUOTING
+ ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstMicroHardened_DEFS     = PROGRAM_NAME_STR="tstMicro"
  else
@@ -472,5 +472,5 @@
 tstPDMAsyncCompletionHardened_TEMPLATE = VBOXR3HARDENEDEXE
 tstPDMAsyncCompletionHardened_NAME     = tstPDMAsyncCompletion
-  ifdef KMK_WITH_QUOTING
+  ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstPDMAsyncCompletionHardened_DEFS     = PROGRAM_NAME_STR="tstPDMAsyncCompletion"
   else
@@ -493,5 +493,5 @@
 tstPDMAsyncCompletionStressHardened_TEMPLATE = VBOXR3HARDENEDEXE
 tstPDMAsyncCompletionStressHardened_NAME     = tstPDMAsyncCompletionStress
-  ifdef KMK_WITH_QUOTING
+  ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 tstPDMAsyncCompletionStressHardened_DEFS     = PROGRAM_NAME_STR="tstPDMAsyncCompletionStress"
   else
Index: trunk/src/VBox/ValidationKit/utils/TestExecServ/Makefile.kmk
===================================================================
--- trunk/src/VBox/ValidationKit/utils/TestExecServ/Makefile.kmk	(revision 84539)
+++ trunk/src/VBox/ValidationKit/utils/TestExecServ/Makefile.kmk	(revision 84540)
@@ -31,5 +31,5 @@
 PROGRAMS += TestExecService
 TestExecService_TEMPLATE = VBoxValidationKitR3
-ifdef KMK_WITH_QUOTING
+ifdef VBOX_WITH_AUTOMATIC_DEFS_QUOTING
 TestExecService_DEFS = \
 	KBUILD_TARGET="$(KBUILD_TARGET)" \