Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.cpp	(revision 84610)
@@ -35,8 +35,8 @@
 
 
-UIVirtualMachineItemCloud::UIVirtualMachineItemCloud()
+UIVirtualMachineItemCloud::UIVirtualMachineItemCloud(UIFakeCloudVirtualMachineItemState enmState)
     : UIVirtualMachineItem(UIVirtualMachineItemType_CloudFake)
     , m_enmMachineState(KCloudMachineState_Invalid)
-    , m_enmFakeCloudItemState(UIFakeCloudVirtualMachineItemState_Loading)
+    , m_enmFakeCloudItemState(enmState)
     , m_pTask(0)
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualMachineItemCloud.h	(revision 84610)
@@ -44,6 +44,6 @@
 public:
 
-    /** Constructs fake cloud VM item. */
-    UIVirtualMachineItemCloud();
+    /** Constructs fake cloud VM item of certain @a enmState. */
+    UIVirtualMachineItemCloud(UIFakeCloudVirtualMachineItemState enmState);
     /** Constructs real cloud VM item on the basis of taken @a comCloudMachine. */
     UIVirtualMachineItemCloud(const CCloudMachine &comCloudMachine);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserAbstractModel.cpp	(revision 84610)
@@ -365,9 +365,8 @@
     /* Create invisible root group node: */
     m_pInvisibleRootNode = new UIChooserNodeGroup(0 /* parent */,
-                                                  false /* favorite */,
                                                   0 /* position */,
+                                                  true /* opened */,
                                                   QString() /* name */,
-                                                  UIChooserNodeGroupType_Local,
-                                                  true /* opened */);
+                                                  UIChooserNodeGroupType_Local);
     if (invisibleRoot())
     {
@@ -377,6 +376,6 @@
         /* Create global node: */
         new UIChooserNodeGlobal(invisibleRoot() /* parent */,
+                                0 /* position */,
                                 shouldGlobalNodeBeFavorite(invisibleRoot()),
-                                0 /* position */,
                                 QString() /* tip */);
 
@@ -446,13 +445,12 @@
             UIChooserNodeGroup *pProviderNode =
                 new UIChooserNodeGroup(invisibleRoot() /* parent */,
-                                       false /* favorite */,
                                        getDesiredNodePosition(invisibleRoot(),
                                                               UIChooserNodeDataPrefixType_Provider,
                                                               strProviderShortName),
-                                       strProviderShortName,
-                                       UIChooserNodeGroupType_Provider,
                                        shouldGroupNodeBeOpened(invisibleRoot(),
                                                                UIChooserNodeDataPrefixType_Provider,
-                                                               strProviderShortName));
+                                                               strProviderShortName),
+                                       strProviderShortName,
+                                       UIChooserNodeGroupType_Provider);
 
             /* Iterate through provider's profiles: */
@@ -471,18 +469,17 @@
                 UIChooserNodeGroup *pProfileNode =
                     new UIChooserNodeGroup(pProviderNode /* parent */,
-                                           false /* favorite */,
                                            getDesiredNodePosition(pProviderNode,
                                                                   UIChooserNodeDataPrefixType_Profile,
                                                                   strProfileName),
-                                           strProfileName,
-                                           UIChooserNodeGroupType_Profile,
                                            shouldGroupNodeBeOpened(pProviderNode,
                                                                    UIChooserNodeDataPrefixType_Profile,
-                                                                   strProfileName));
+                                                                   strProfileName),
+                                           strProfileName,
+                                           UIChooserNodeGroupType_Profile);
 
                 /* Add fake cloud VM item: */
                 new UIChooserNodeMachine(pProfileNode /* parent */,
-                                         false /* favorite */,
-                                         0 /* position */);
+                                         0 /* position */,
+                                         UIFakeCloudVirtualMachineItemState_Loading);
 
                 /* Create list cloud machines task: */
@@ -770,10 +767,7 @@
         {
             /* Add fake cloud VM item: */
-            UIChooserNodeMachine *pFakeNode = new UIChooserNodeMachine(pProfileNode /* parent */,
-                                                                       false /* favorite */,
-                                                                       0 /* position */);
-            AssertPtrReturnVoid(pFakeNode);
-            AssertReturnVoid(pFakeNode->cacheType() == UIVirtualMachineItemType_CloudFake);
-            pFakeNode->cache()->toCloud()->setFakeCloudItemState(UIFakeCloudVirtualMachineItemState_Done);
+            new UIChooserNodeMachine(pProfileNode /* parent */,
+                                     0 /* position */,
+                                     UIFakeCloudVirtualMachineItemState_Done);
         }
     }
@@ -1028,13 +1022,12 @@
     UIChooserNodeGroup *pNewGroupNode =
         new UIChooserNodeGroup(pParentNode,
-                               false /* favorite */,
                                getDesiredNodePosition(pParentNode,
                                                       UIChooserNodeDataPrefixType_Local,
                                                       strSecondSubName),
-                               strSecondSubName,
-                               UIChooserNodeGroupType_Local,
                                fAllGroupsOpened || shouldGroupNodeBeOpened(pParentNode,
                                                                            UIChooserNodeDataPrefixType_Local,
-                                                                           strSecondSubName));
+                                                                           strSecondSubName),
+                               strSecondSubName,
+                               UIChooserNodeGroupType_Local);
     return strSecondSuffix.isEmpty() ? pNewGroupNode : getLocalGroupNode(strFirstSuffix, pNewGroupNode, fAllGroupsOpened);
 }
@@ -1300,5 +1293,4 @@
 {
     new UIChooserNodeMachine(pParentNode,
-                             false /* favorite */,
                              getDesiredNodePosition(pParentNode,
                                                     UIChooserNodeDataPrefixType_Machine,
@@ -1310,5 +1302,4 @@
 {
     UIChooserNodeMachine *pNode = new UIChooserNodeMachine(pParentNode,
-                                                           false /* favorite */,
                                                            getDesiredNodePosition(pParentNode,
                                                                                   UIChooserNodeDataPrefixType_Machine,
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserHandlerKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserHandlerKeyboard.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserHandlerKeyboard.cpp	(revision 84610)
@@ -369,5 +369,5 @@
         case UIChooserNodeType_Group:
         {
-            UIChooserNodeGroup *pNewNode = new UIChooserNodeGroup(pParentNode, pCurrentNode->toGroupNode(), iNewCurrentNodePosition);
+            UIChooserNodeGroup *pNewNode = new UIChooserNodeGroup(pParentNode, iNewCurrentNodePosition, pCurrentNode->toGroupNode());
             pShiftedItem = new UIChooserItemGroup(pParentNode->item(), pNewNode);
             break;
@@ -375,5 +375,5 @@
         case UIChooserNodeType_Machine:
         {
-            UIChooserNodeMachine *pNewNode = new UIChooserNodeMachine(pParentNode, pCurrentNode->toMachineNode(), iNewCurrentNodePosition);
+            UIChooserNodeMachine *pNewNode = new UIChooserNodeMachine(pParentNode, iNewCurrentNodePosition, pCurrentNode->toMachineNode());
             pShiftedItem = new UIChooserItemMachine(pParentNode->item(), pNewNode);
             break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 84610)
@@ -823,5 +823,5 @@
 
                 /* Copy passed group-item into this group: */
-                UIChooserNodeGroup *pNewGroupNode = new UIChooserNodeGroup(node(), pNode->toGroupNode(), iPosition);
+                UIChooserNodeGroup *pNewGroupNode = new UIChooserNodeGroup(node(), iPosition, pNode->toGroupNode());
                 UIChooserItemGroup *pNewGroupItem = new UIChooserItemGroup(this, pNewGroupNode);
                 if (isClosed())
@@ -877,5 +877,5 @@
 
                 /* Copy passed machine-item into this group: */
-                UIChooserNodeMachine *pNewMachineNode = new UIChooserNodeMachine(node(), pNode->toMachineNode(), iPosition);
+                UIChooserNodeMachine *pNewMachineNode = new UIChooserNodeMachine(node(), iPosition, pNode->toMachineNode());
                 UIChooserItemMachine *pNewMachineItem = new UIChooserItemMachine(this, pNewMachineNode);
                 if (isClosed())
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 84610)
@@ -466,17 +466,16 @@
                 /* Group passed item with current-item into the new group: */
                 UIChooserNodeGroup *pNewGroupNode = new UIChooserNodeGroup(parentItem()->node(),
-                                                                           false /* favorite */,
                                                                            parentItem()->node()->nodes().size(),
+                                                                           true /* opened */,
                                                                            UIChooserModel::uniqueGroupName(parentItem()->node()),
-                                                                           parentItem()->node()->toGroupNode()->groupType(),
-                                                                           true /* true */);
+                                                                           parentItem()->node()->toGroupNode()->groupType());
                 UIChooserItemGroup *pNewGroupItem = new UIChooserItemGroup(parentItem(), pNewGroupNode);
                 UIChooserNodeMachine *pNewMachineNode1 = new UIChooserNodeMachine(pNewGroupNode,
-                                                                                  nodeToMachineType(),
-                                                                                  pNewGroupNode->nodes().size());
+                                                                                  pNewGroupNode->nodes().size(),
+                                                                                  nodeToMachineType());
                 new UIChooserItemMachine(pNewGroupItem, pNewMachineNode1);
                 UIChooserNodeMachine *pNewMachineNode2 = new UIChooserNodeMachine(pNewGroupNode,
-                                                                                  pNode->toMachineNode(),
-                                                                                  pNewGroupNode->nodes().size());
+                                                                                  pNewGroupNode->nodes().size(),
+                                                                                  pNode->toMachineNode());
                 new UIChooserItemMachine(pNewGroupItem, pNewMachineNode2);
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 84610)
@@ -652,6 +652,6 @@
             {
                 UIChooserNodeGroup *pGroupNode = new UIChooserNodeGroup(pParentNode,
-                                                                        pNode->toGroupNode(),
-                                                                        pParentNode->nodes().size());
+                                                                        pParentNode->nodes().size(),
+                                                                        pNode->toGroupNode());
                 UIChooserItemGroup *pGroupItem = new UIChooserItemGroup(pParentItem, pGroupNode);
                 if (childrenToBeRenamed.contains(pNode))
@@ -663,6 +663,6 @@
             {
                 UIChooserNodeMachine *pMachineNode = new UIChooserNodeMachine(pParentNode,
-                                                                              pNode->toMachineNode(),
-                                                                              pParentNode->nodes().size());
+                                                                              pParentNode->nodes().size(),
+                                                                              pNode->toMachineNode());
                 UIChooserItemMachine *pMachineItem = new UIChooserItemMachine(pParentItem, pMachineNode);
                 ungroupedItems << pMachineItem;
@@ -775,9 +775,8 @@
         /* Create new group node in the current root: */
         pTargetGroupNode = new UIChooserNodeGroup(invisibleRoot(),
-                                                  false /* favorite */,
                                                   invisibleRoot()->nodes().size() /* position */,
+                                                  true /* opened */,
                                                   uniqueGroupName(invisibleRoot()),
-                                                  UIChooserNodeGroupType_Local,
-                                                  true /* opened */);
+                                                  UIChooserNodeGroupType_Local);
         pTargetGroupItem = new UIChooserItemGroup(root(), pTargetGroupNode);
     }
@@ -815,6 +814,6 @@
                 /* Copy or move group-item: */
                 UIChooserNodeGroup *pNewGroupSubNode = new UIChooserNodeGroup(pTargetGroupNode,
-                                                                              pItem->node()->toGroupNode(),
-                                                                              pTargetGroupNode->nodes().size());
+                                                                              pTargetGroupNode->nodes().size(),
+                                                                              pItem->node()->toGroupNode());
                 copiedItems << new UIChooserItemGroup(pTargetGroupItem, pNewGroupSubNode);
                 delete pItem->node();
@@ -830,6 +829,6 @@
                 /* Copy or move machine-item: */
                 UIChooserNodeMachine *pNewMachineSubNode = new UIChooserNodeMachine(pTargetGroupNode,
-                                                                                    pItem->node()->toMachineNode(),
-                                                                                    pTargetGroupNode->nodes().size());
+                                                                                    pTargetGroupNode->nodes().size(),
+                                                                                    pItem->node()->toMachineNode());
                 copiedItems << new UIChooserItemMachine(pTargetGroupItem, pNewMachineSubNode);
                 delete pItem->node();
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.cpp	(revision 84610)
@@ -25,6 +25,6 @@
 
 UIChooserNodeGlobal::UIChooserNodeGlobal(UIChooserNode *pParent,
+                                         int iPosition,
                                          bool fFavorite,
-                                         int iPosition,
                                          const QString &)
     : UIChooserNode(pParent, fFavorite)
@@ -39,6 +39,6 @@
 
 UIChooserNodeGlobal::UIChooserNodeGlobal(UIChooserNode *pParent,
-                                         UIChooserNodeGlobal *pCopyFrom,
-                                         int iPosition)
+                                         int iPosition,
+                                         UIChooserNodeGlobal *pCopyFrom)
     : UIChooserNode(pParent, pCopyFrom->isFavorite())
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.h	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGlobal.h	(revision 84610)
@@ -34,17 +34,17 @@
 
     /** Constructs chooser node passing @a pParent to the base-class.
+      * @param  iPosition  Brings the initial node position.
       * @param  fFavorite  Brings whether the node is favorite.
-      * @param  iPosition  Brings the initial node position.
       * @param  strTip     Brings the dummy tip. */
     UIChooserNodeGlobal(UIChooserNode *pParent,
+                        int iPosition,
                         bool fFavorite,
-                        int iPosition,
                         const QString &strTip);
     /** Constructs chooser node passing @a pParent to the base-class.
-      * @param  pCopyFrom  Brings the node to copy data from.
-      * @param  iPosition  Brings the initial node position. */
+      * @param  iPosition  Brings the initial node position.
+      * @param  pCopyFrom  Brings the node to copy data from. */
     UIChooserNodeGlobal(UIChooserNode *pParent,
-                        UIChooserNodeGlobal *pCopyFrom,
-                        int iPosition);
+                        int iPosition,
+                        UIChooserNodeGlobal *pCopyFrom);
     /** Destructs chooser node. */
     virtual ~UIChooserNodeGlobal() /* override */;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.cpp	(revision 84610)
@@ -27,13 +27,12 @@
 
 UIChooserNodeGroup::UIChooserNodeGroup(UIChooserNode *pParent,
-                                       bool fFavorite,
                                        int iPosition,
+                                       bool fOpened,
                                        const QString &strName,
-                                       UIChooserNodeGroupType enmGroupType,
-                                       bool fOpened)
-    : UIChooserNode(pParent, fFavorite)
+                                       UIChooserNodeGroupType enmGroupType)
+    : UIChooserNode(pParent, false /* favorite */)
+    , m_fOpened(fOpened)
     , m_strName(strName)
     , m_enmGroupType(enmGroupType)
-    , m_fOpened(fOpened)
 {
     /* Add to parent: */
@@ -46,7 +45,7 @@
 
 UIChooserNodeGroup::UIChooserNodeGroup(UIChooserNode *pParent,
-                                       UIChooserNodeGroup *pCopyFrom,
-                                       int iPosition)
-    : UIChooserNode(pParent, pCopyFrom->isFavorite())
+                                       int iPosition,
+                                       UIChooserNodeGroup *pCopyFrom)
+    : UIChooserNode(pParent, false /* favorite */)
     , m_strName(pCopyFrom->name())
     , m_enmGroupType(pCopyFrom->groupType())
@@ -301,8 +300,8 @@
 {
     foreach (UIChooserNode *pNode, pCopyFrom->nodes(UIChooserNodeType_Group))
-        new UIChooserNodeGroup(this, pNode->toGroupNode(), m_nodesGroup.size());
+        new UIChooserNodeGroup(this, m_nodesGroup.size(), pNode->toGroupNode());
     foreach (UIChooserNode *pNode, pCopyFrom->nodes(UIChooserNodeType_Global))
-        new UIChooserNodeGlobal(this, pNode->toGlobalNode(), m_nodesGlobal.size());
+        new UIChooserNodeGlobal(this, m_nodesGlobal.size(), pNode->toGlobalNode());
     foreach (UIChooserNode *pNode, pCopyFrom->nodes(UIChooserNodeType_Machine))
-        new UIChooserNodeMachine(this, pNode->toMachineNode(), m_nodesMachine.size());
-}
+        new UIChooserNodeMachine(this, m_nodesMachine.size(), pNode->toMachineNode());
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.h	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeGroup.h	(revision 84610)
@@ -34,21 +34,19 @@
 
     /** Constructs chooser node passing @a pParent to the base-class.
-      * @param  fFavorite     Brings whether the node is favorite.
-      * @param  iPosition     Brings the initial node position.
+      * @param  iPosition     Brings the initial node position
+      * @param  fOpened       Brings whether this group node is opened..
       * @param  strName       Brings current node name.
-      * @param  enmGroupType  Brings group node type.
-      * @param  fOpened       Brings whether this group node is opened. */
+      * @param  enmGroupType  Brings group node type. */
     UIChooserNodeGroup(UIChooserNode *pParent,
-                       bool fFavorite,
                        int iPosition,
+                       bool fOpened,
                        const QString &strName,
-                       UIChooserNodeGroupType enmGroupType,
-                       bool fOpened);
+                       UIChooserNodeGroupType enmGroupType);
     /** Constructs chooser node passing @a pParent to the base-class.
-      * @param  pCopyFrom  Brings the node to copy data from.
-      * @param  iPosition  Brings the initial node position. */
+      * @param  iPosition  Brings the initial node position.
+      * @param  pCopyFrom  Brings the node to copy data from. */
     UIChooserNodeGroup(UIChooserNode *pParent,
-                       UIChooserNodeGroup *pCopyFrom,
-                       int iPosition);
+                       int iPosition,
+                       UIChooserNodeGroup *pCopyFrom);
     /** Destructs chooser node removing it's children. */
     virtual ~UIChooserNodeGroup() /* override */;
@@ -120,10 +118,10 @@
     void copyContents(UIChooserNodeGroup *pCopyFrom);
 
+    /** Holds whether node is opened. */
+    bool                    m_fOpened;
     /** Holds the node name. */
     QString                 m_strName;
     /** Holds the group node type. */
     UIChooserNodeGroupType  m_enmGroupType;
-    /** Holds whether node is opened. */
-    bool                    m_fOpened;
 
     /** Holds group children. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.cpp	(revision 84610)
@@ -24,8 +24,7 @@
 
 UIChooserNodeMachine::UIChooserNodeMachine(UIChooserNode *pParent,
-                                           bool fFavorite,
-                                           int  iPosition,
+                                           int iPosition,
                                            const CMachine &comMachine)
-    : UIChooserNode(pParent, fFavorite)
+    : UIChooserNode(pParent, false /* favorite */)
     , m_pCache(new UIVirtualMachineItemLocal(comMachine))
 {
@@ -39,8 +38,7 @@
 
 UIChooserNodeMachine::UIChooserNodeMachine(UIChooserNode *pParent,
-                                           bool fFavorite,
                                            int iPosition,
                                            const CCloudMachine &comCloudMachine)
-    : UIChooserNode(pParent, fFavorite)
+    : UIChooserNode(pParent, false /* favorite */)
     , m_pCache(new UIVirtualMachineItemCloud(comCloudMachine))
 {
@@ -60,20 +58,20 @@
 
 UIChooserNodeMachine::UIChooserNodeMachine(UIChooserNode *pParent,
-                                           bool fFavorite,
-                                           int  iPosition)
-    : UIChooserNode(pParent, fFavorite)
-    , m_pCache(new UIVirtualMachineItemCloud)
-{
-    /* Add to parent: */
-    if (parentNode())
-        parentNode()->addNode(this, iPosition);
-
-    /* Apply language settings: */
-    retranslateUi();
-}
-
-UIChooserNodeMachine::UIChooserNodeMachine(UIChooserNode *pParent,
-                                           UIChooserNodeMachine *pCopyFrom,
-                                           int iPosition)
+                                           int iPosition,
+                                           UIFakeCloudVirtualMachineItemState enmState)
+    : UIChooserNode(pParent, false /* favorite */)
+    , m_pCache(new UIVirtualMachineItemCloud(enmState))
+{
+    /* Add to parent: */
+    if (parentNode())
+        parentNode()->addNode(this, iPosition);
+
+    /* Apply language settings: */
+    retranslateUi();
+}
+
+UIChooserNodeMachine::UIChooserNodeMachine(UIChooserNode *pParent,
+                                           int iPosition,
+                                           UIChooserNodeMachine *pCopyFrom)
     : UIChooserNode(pParent, pCopyFrom->isFavorite())
 {
@@ -85,5 +83,5 @@
             break;
         case UIVirtualMachineItemType_CloudFake:
-            m_pCache = new UIVirtualMachineItemCloud;
+            m_pCache = new UIVirtualMachineItemCloud(pCopyFrom->cache()->toCloud()->fakeCloudItemState());
             break;
         case UIVirtualMachineItemType_CloudReal:
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.h	(revision 84598)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserNodeMachine.h	(revision 84610)
@@ -40,31 +40,27 @@
 
     /** Constructs chooser node for local VM passing @a pParent to the base-class.
-      * @param  fFavorite   Brings whether the node is favorite.
       * @param  iPosition   Brings initial node position.
       * @param  comMachine  Brings COM machine object. */
     UIChooserNodeMachine(UIChooserNode *pParent,
-                         bool fFavorite,
                          int iPosition,
                          const CMachine &comMachine);
     /** Constructs chooser node for real cloud VM passing @a pParent to the base-class.
-      * @param  fFavorite        Brings whether the node is favorite.
       * @param  iPosition        Brings initial node position.
       * @param  comCloudMachine  Brings COM cloud machine object. */
     UIChooserNodeMachine(UIChooserNode *pParent,
-                         bool fFavorite,
                          int iPosition,
                          const CCloudMachine &comCloudMachine);
     /** Constructs chooser node for fake cloud VM passing @a pParent to the base-class.
-      * @param  fFavorite  Brings whether the node is favorite.
-      * @param  iPosition  Brings the initial node position. */
+      * @param  iPosition  Brings the initial node position.
+      * @param  enmState   Brings fake item type. */
     UIChooserNodeMachine(UIChooserNode *pParent,
-                         bool fFavorite,
-                         int iPosition);
+                         int iPosition,
+                         UIFakeCloudVirtualMachineItemState enmState);
     /** Constructs chooser node passing @a pParent to the base-class.
-      * @param  pCopyFrom  Brings the node to copy data from.
-      * @param  iPosition  Brings the initial node position. */
+      * @param  iPosition  Brings the initial node position.
+      * @param  pCopyFrom  Brings the node to copy data from. */
     UIChooserNodeMachine(UIChooserNode *pParent,
-                         UIChooserNodeMachine *pCopyFrom,
-                         int iPosition);
+                         int iPosition,
+                         UIChooserNodeMachine *pCopyFrom);
     /** Destructs chooser node. */
     virtual ~UIChooserNodeMachine() /* override */;